DAT objectName         byte "HalloweenHexQsHeader141109a", 0
CON{

  140130a Big change. Change the way the legs are numbered.
  Starboard center is now #0. Starboard front #1. Port front #2.
  Center port #3, rear port #4 and rear starboard #5.
  140924a Change to North, East, Down (NED) coordinate system.
  Renumber feet and servos starting with front right.
  
}
CON

  CRYSTAL_FREQUENCY = 5_000_000
  
  TAU = 2.0 * pi
  TAU_OVER_4 = pi / 2.0
                                     
  S00 = 1550 
  S01 = 1400
  S02 = 1510
   
  S03 = 1500
  S04 = 1415
  S05 = 1460
   
  S06 = 1450
  S07 = 1500
  S08 = 1500
   
  S09 = 1570
  S10 = 1500
  S11 = 1370
   
  S12 = 1540
  S13 = 1500
  S14 = 1510
   
  S15 = 1350
  S16 = 1500
  S17 = 1420

  RIGHT_LOW_CENTER = 1320
  RIGHT_TOP_CENTER = 1400 
  LEFT_LOW_CENTER = 1430 
  LEFT_TOP_CENTER = 1400
  
  LOW_PINS_DIRECTION = 1
  HIGH_PINS_DIRECTION = 1
   
  P00 = 0 
  P01 = P00 + LOW_PINS_DIRECTION
  P02 = P01 + LOW_PINS_DIRECTION

  P03 = P02 + LOW_PINS_DIRECTION 
  P04 = P03 + LOW_PINS_DIRECTION 
  P05 = P04 + LOW_PINS_DIRECTION 

  P06 = P05 + LOW_PINS_DIRECTION 
  P07 = P06 + LOW_PINS_DIRECTION
  P08 = P07 + LOW_PINS_DIRECTION

  P09 = 14
  P10 = P09 + HIGH_PINS_DIRECTION
  P11 = P10 + HIGH_PINS_DIRECTION

  P12 = P11 + HIGH_PINS_DIRECTION 
  P13 = P12 + HIGH_PINS_DIRECTION
  P14 = P13 + HIGH_PINS_DIRECTION

  P15 = P14 + HIGH_PINS_DIRECTION 
  P16 = P15 + HIGH_PINS_DIRECTION
  P17 = P16 + HIGH_PINS_DIRECTION

  RIGHT_TOP_PIN = 10
  LEFT_TOP_PIN = 26
  RIGHT_LOW_PIN = 9
  LEFT_LOW_PIN = 23

  LED_DATA = 12
  LED_CLOCK = 11
  LED_LATCH = 13
  
  #0, RC_CHANNEL_THROTTLE, RC_CHANNEL_X, RC_CHANNEL_Y, RC_CHANNEL_YAW, RC_CHANNEL_GEAR, RC_CHANNEL_EXTRA

  RC_BASE_PIN = 0
  RC_PIN_THROTTLE = RC_BASE_PIN + RC_CHANNEL_THROTTLE
  RC_PIN_X = RC_BASE_PIN + RC_CHANNEL_X
  RC_PIN_Y = RC_BASE_PIN + RC_CHANNEL_Y
  RC_PIN_YAW = RC_BASE_PIN + RC_CHANNEL_YAW
  RC_PIN_GEAR = RC_BASE_PIN + RC_CHANNEL_GEAR
  RC_PIN_EXTRA = RC_BASE_PIN + RC_CHANNEL_EXTRA

  XBEE_RX_PIN = 11
  XBEE_TX_PIN = 10

  ADC_PIN_MISO = 24
  ADC_PIN_MOSI = 25
  ADC_PIN_CLOCK = 26
  ADC_PIN_CS = -1 '27
  
  
                ' positive rotation of leg is ccw, since servo is on the leg
                ' it needs to rotate cw (negative) to produce a positive angle.
                ' Since the waist servo all need a negative direction, think
  D00 = 1      ' about hard coding the value into the equations.
  
  D01 = -1      ' Positive angle lifts leg.  Think about changing legs so all
                ' face the same direction.
                
  D02 = 1       ' Positive angle points leg outward.
  
  D03 = 1
  D04 = -1
  D05 = 1
  
  D06 = 1
  D07 = -1
  D08 = 1
  
  D09 = 1
  D10 = 1
  D11 = -1
  
  D12 = 1
  D13 = 1
  D14 = -1
  
  D15 = 1
  D16 = 1
  D17 = -1
   
  A00 = TAU / 12.0              ' (1.0 * TAU) / 12.0 
  A01 = TAU / 4.0               ' (3.0 * TAU) / 12.0
  A02 = (5.0 * TAU) / 12.0      ' (5.0 * TAU) / 12.0
  A03 = (7.0 * TAU) / 12.0      ' (7.0 * TAU) / 12.0
  A04 = (3.0 * TAU) / 4.0       ' (9.0 * TAU) / 12.0
  A05 = (11.0 * TAU) / 12.0     ' (11.0 * TAU) / 12.0
    
  F_COXA = 41.4 ' Halloween Hex 
  F_FEMUR = 84.2 ' Halloween Hex
  F_TIBIA = 126.0 ' Halloween Hex

  F_FEMUR_SQUARED = F_FEMUR * F_FEMUR
  F_TIBIA_SQUARED = F_TIBIA * F_TIBIA
  F_TWO_FEMUR_TIBIA = 2.0 * F_FEMUR * F_TIBIA
  F_TWO_FEMUR = 2.0 * F_FEMUR 
  F_SUM_SQUARES_FEMUR_TIBIA = F_FEMUR_SQUARED + F_TIBIA_SQUARED

  US_PER_TAU = 4000
  US_PER_QUARTER_TAU = US_PER_TAU / 4
  F_US_PER_RADIAN = float(US_PER_TAU) / TAU

  F_DEFAULT_REST_X = 10.0
  F_DEFAULT_REST_Y = 10.0
  F_DEFAULT_REST_Z = 37.0
  
CON

  F_BOT_WIDTH_MIDDLE = 128.6
  F_BOT_WIDTH = 79.2
  F_BOT_LENGTH = 149.2


  ''     Leg Numbers
  ''        Front
  ''        5  0
  '' Port  4    1 Starboard
  ''        3  2
  ''        Rear
  ''
  ''         ^ +X or North
  ''         |
  ''         |
  ''     ----+-----> +Y or East
  ''         |
  ''         |
  ''     +Z or down into the screen
  '' 0,0,0  in bot frame is the center of the robot at the level of the knee
  '' pivot.
  ''
  '' 0,0,0 in leg frame is the center of the hip pivot (x,y) at the level
  '' of the knee pivot (z).
  ''
  '' 0 degrees of leg angle with respect to 0 degreess of robot frame listed as A00 - A05.
  '' 0 degrees in robot frame is aligned with X-axis.
  
  
  ' Bot Frame
  F_FROM_CENTER_X_0 = F_BOT_LENGTH / 2.0
  F_FROM_CENTER_X_1 = 0.0
  F_FROM_CENTER_X_2 = -1.0 * F_FROM_CENTER_X_0
  F_FROM_CENTER_X_3 = F_FROM_CENTER_X_2
  F_FROM_CENTER_X_4 = F_FROM_CENTER_X_1
  F_FROM_CENTER_X_5 = F_FROM_CENTER_X_0
  
  F_FROM_CENTER_Y_0 = F_BOT_WIDTH / 2.0
  F_FROM_CENTER_Y_1 = F_BOT_WIDTH_MIDDLE / 2.0
  F_FROM_CENTER_Y_2 = F_FROM_CENTER_Y_0
  F_FROM_CENTER_Y_3 = -1.0 * F_FROM_CENTER_Y_0
  F_FROM_CENTER_Y_4 = -1.0 * F_FROM_CENTER_Y_1
  F_FROM_CENTER_Y_5 = F_FROM_CENTER_Y_3
  
  ' Leg Frame
  F_DEFAULT_X = F_COXA + F_FEMUR
  F_DEFAULT_Y = 0.0
  F_DEFAULT_Z = F_TIBIA
  
  F_DEFAULT_STRIDE_LENGTH = F_DEFAULT_X * 0.7 '2.0 ' Stride is now distance traveled after one
                                              ' full cycle.
  F_DEFAULT_LIFT_X = 0.0 
  F_DEFAULT_LIFT_Y = 0.0 
  F_DEFAULT_LIFT_Z = F_TIBIA / 2.0

  F_ROOT_3_OVER_2 = 0.866025

  ' half torque on hip servo, raise hip 60 degrees
  F_DEFAULT_LOW_STANCE_X = F_COXA + (F_FEMUR / 2.0)
  F_DEFAULT_LOW_STANCE_Y = 0.0
  F_DEFAULT_LOW_STANCE_Z = F_ROOT_3_OVER_2 * F_TIBIA

  ' half torque on hip servo, lower hip 60 degrees 
  F_DEFAULT_HIGH_STANCE_X = F_DEFAULT_LOW_STANCE_X
  F_DEFAULT_HIGH_STANCE_Y = F_DEFAULT_LOW_STANCE_Y
  F_DEFAULT_HIGH_STANCE_Z = F_DEFAULT_LOW_STANCE_Z + F_TIBIA

  #0, WAIST, HIP, KNEE
  
PUB GetObjectName

  result := @objectName
    
PUB ServoCenterAddress

  result := @servoCenter

PUB GetServoCenter(localIndex)

  result := servoCenter[localIndex]

PUB PinAddress

  result := @pinNumber

PUB GetPin(localIndex)

  result := pinNumber[localIndex]

PUB DirectionAddress

  result := @direction

PUB GetRadiusOffsetX(localIndex)

  result := fFromCenterX[localIndex]
  
PUB GetRadiusOffsetY(localIndex)

  result := fFromCenterY[localIndex]
  
PUB AngleAddress

  result := @fAngle
  
PUB GetSegmentLength(localIndex)

  result := fJointLength[localIndex]
  
DAT

servoCenter   long S00, S01, S02
              long S03, S04, S05
              long S06, S07, S08
              long S09, S10, S11
              long S12, S13, S14
              long S15, S16, S17
              long RIGHT_LOW_CENTER, RIGHT_TOP_CENTER
              long LEFT_LOW_CENTER, LEFT_TOP_CENTER
              
pinNumber     byte P00, P01, P02
              byte P03, P04, P05
              byte P06, P07, P08
              byte P09, P10, P11
              byte P12, P13, P14
              byte P15, P16, P17
              byte RIGHT_LOW_PIN, RIGHT_TOP_PIN
              byte LEFT_LOW_PIN, LEFT_TOP_PIN
   
direction     long D00, D01, D02
              long D03, D04, D05
              long D06, D07, D08
              long D09, D10, D11
              long D12, D13, D14
              long D15, D16, D17
              long -1[4]

fFromCenterX  long F_FROM_CENTER_X_0, F_FROM_CENTER_X_1, F_FROM_CENTER_X_2
              long F_FROM_CENTER_X_3, F_FROM_CENTER_X_4, F_FROM_CENTER_X_5

fFromCenterY  long F_FROM_CENTER_Y_0, F_FROM_CENTER_Y_1, F_FROM_CENTER_Y_2
              long F_FROM_CENTER_Y_3, F_FROM_CENTER_Y_4, F_FROM_CENTER_Y_5

fAngle        long A00, A01, A02
              long A03, A04, A05

fJointLength  long F_COXA, F_FEMUR, F_TIBIA
                                                                 