DAT objectName          byte "HeaderHexapodCom140209a", 0
CON
{ Private Notes
  140102a Rename from "RobotHeader131110a" to
  "HeaderHexapd140102a". Remove most of the
  constants.
  02b Switch to size of message as part of header
  instead of using end of message character.
  

}
 ' EEPROM Use
{


  $FF00  |                   |                   |                   |                   |
  $FF10  |                   |                   |                   |                   |
  $FF20  |                   |                   |                   |                   |
  $FF30  |                   |                   |                   |                   |
  $FF40  |                   |                   |                   |                   |
  $FF50  |                   |                   |                   |                   |
  $FF60  |                   |                   |                   |                   |
  $FF70  |                   |                   |                   |                   |
  $FF80  |                   |                   |                   |                   |
  $FF90  |                   |                   |                   |                   |
  $FF00  |                   |                   |                   |                   |
  $FFA0  |                   |                   |                   |                   |
  $FFC0  |        6          |        6          |        5          |        5          |
  $FFD0  |        4          |        4          |        3          |        3          |
  $FFE0  | Unit #2 firmware  |subV2, code2, X, X | Unit #1 firmware  |subV1, code1, X, X |
  $FFF0  | FIRMWAREVersion  |FIRMWARESubVersion|                   |     Unit ID       |
  
  The basestation will have the firmware version of each other unit in it's EEPROM.
  Unit #N's fw location = FIRMWARELocation - (N * FIRMWAREDiscriptionSize)

  Each Propeller with an permanently attached EEPROM (with 64K or more space)
  should have a unique ID.

  ID numbers 1 through 7 are QuickStart boards
  A label with the Propeller's ID number should be attached to the board when the ID
  number is assigned.
  
  Some Propeller IDs

  
}
  FIRMWARE_DISCRIPTION_SIZE = 8 ' 4 for date, 1 for subV letter, 3 for other codes
                               ' codes include fw update started or successfully finished
  FIRMWARE_VERION = 140102  ' 4 bytes
  FIRMWARE_SUB_VERION = "a"  ' 1 byte, for now the following three bytes
  FIRMWARE_LOCATION = $FFF0
  FIRMWARE_SUB_LOCATION = FIRMWARE_LOCATION + 4 ' three last bytes aren't used yet
  ID_EEPROM_LOCATION = $FFFC 'FIRMWARE_LOCATION + 12 ' 4 bytes
  ' Unique to each Propeller
  
  SYSTEM_ID_EEPROM_LOCATION = $FFF8 'FIRMWARE_LOCATION + 12 ' 4 bytes
  ' Used in multi Propeller systems.
  
  FIRST_PROTECTED_EEPROM = FIRMWARE_LOCATION
  END_OF_PROTECTED_EEPROM = FIRMWARE_LOCATION + 16
  FIRMWARE_SCRATCH_PAD_LOCATION = $8000 ' use for wireless firmware updates

  
  ' EEPROM firmware update codes
  #0, NO_INFO_YET_FW, UPDATE_STARTED_FW, UPDATE_COMPLETE_FW ' Firmware updates will first be copied
                                                      ' to uppper EEPROM then from upper EEPROM
                                                      ' to lower EEPROM.
  SERVO_CENTER_EEPROM_LOCATION = $FFC0 - (18 * 4)
  SERVO_PIN_EEPROM_LOCATION = SERVO_CENTER_EEPROM_LOCATION - 18
  DEFAULT_UPPER_EEPROM_FLAG = 1
                                                         
CON  
  ' control character enumeration
  #0, NULL, START_OF_HEADER, START_TEXT
  CARRIAGE_RETURN = 13
  GROUP_SEPARATOR = 29
  COM_ATTENTION = $7E        
  PROP_TO_PROP_REMOTE_BAUD = 115_200
  DEBUG_REMOTE_BAUD = PROP_TO_PROP_REMOTE_BAUD
                         
  ' com type enumeration
  #1, DIRECT_SINGLE_PACKET_WIRELESS, HOPPING_SINGLE_PACKET_WIRELESS, {
    } DIRECT_ASCII_WIRELESS, HOPPING_ASCII_WIRELESS, {
    } DIRECT_SINGLE_PACKET, HOPPING_SINGLE_PACKET, DIRECT_ASCII, {
    } HOPPING_ASCII, EIGHT_BIT {Probably not needed since an 8-bit line
    will know it's an 8-bit line.} 
  ' both DIRECT_ASCII_WIRELESS, HOPPING_ASCII_WIRELESS messages
  ' should only transmit a byte with the value of 13 as an end of message
  ' character.  Data should be sent as ASCII hexidecimal to avoid sending
  ' a 13 other than at the end of a message.
  ' I use a serial driver that watches for an end of message character so
  ' I don't want the end of message character showing up other than at the
  ' end of a message.  These two com types are likely used with XBee modules.

  ' I have yet to come up with a "hopping" protocol.
  
 
  ' transmission type
  #1, CONTROLLER_STREAM, DATA_OUT_NO_REPLY, DATA_EXPECT_REPLY, COMMAND, ENQUIRE, {
    } ACKNOWLEDGE, ENQUIRE_REPLY
  
  ' subtypes of CONTROLLER_STREAM
  #1, PS2_JOYSTICKS_ONLY, PS2_JOYSTICKS_PLUS_BUTTON_BITS, PS2_JOYSTICKS_PLUS_ANALOG, {
    } PS2_JOYSTICKS_PLUS_BOTH
  ' subtypes of CONTROLLER_STREAM offset enumeration
  ' PS2_JOYSTICKS_ONLY  four data bytes after subtype total length 6
  ' PS2_JOYSTICKS_PLUS_BUTTON_BITS  eight data bytes after subtype total length 10
  ' PS2_JOYSTICKS_PLUS_ANALOG  four data bytes then number of analog channels. Each
  ' channel takes two bytes. First byte is channel # and second byte is channel value.
  ' Total length 7 + (2 * # of channels)
  ' PS2_JOYSTICKS_PLUS_BOTH  eight data bytes after subtype followed by number of analog
  ' channels. Total length 11 + (2 * # of channels)
  
  
  ' offset enumeration
  #0, START_TRANSMISSION_OFFSET, MESSAGE_COUNT_OFFSET, DESTINATION_OFFSET, {
    } SOURCE_OFFSET, TRANSMISSION_LENGTH_OFFSET, TRANSMISSION_TYPE_OFFSET, SUB_TYPE_OFFSET, {
    } BEGINNING_OF_PARAMETERS_OFFSET  

  ' DATA types
  #0, FILE_NAME_DATA, MESSAGES_RECEIVED_DATA
 

  ' The value transmitted in the "TRANSMISSION_TYPE_OFFSET " position will indicate 
  ' the number of bytes remaining in the transmission.
  
  COUNT_BEING_ACK_OFFSET = SUB_TYPE_OFFSET

  ' transmission targets and sources

  Q4_REMOTE = "Q" ' remote from Quantum Robotics
  HEXAPOD_Q = "h" ' small Hexapod from Quantum Roboitics
  PS2_TOUCHSCREEN = "P" ' remote with PlayStation 2 controller and touchscreen
  MECANUM_R5 = "m" ' Mecanum wheeled Rover 5
    
  DEBUG_TX_PIN = 30 
  DEBUG_RX_PIN = 31

CON

{  _CenterStickPs2 = 123
  _CenterPs2LeftXMin = 114
  _CenterPs2LeftXMax = 148 '142
  _CenterPs2LeftYMin = 119
  _CenterPs2LeftYMax = 135 '126
  _CenterPs2RightXMin = 101 '102
  _CenterPs2RightXMax = 141 '139
  _CenterPs2RightYMin = 100
  _CenterPs2RightYMax = 128 '126
  _CenterPs2LeftXSize = _CenterPs2LeftXMax - _CenterPs2LeftXMin
  _CenterPs2LeftYSize = _CenterPs2LeftYMax - _CenterPs2LeftYMin
  _CenterPs2RightXSize = _CenterPs2RightXMax - _CenterPs2RightXMin
  _CenterPs2RightYSize = _CenterPs2RightYMax - _CenterPs2RightYMin
  _Ps2JoyMax = $FF    }
  CENTER_STICK_PS2 = 123
  DEADZONE_PS2 = 10
  CENTER_PS2_RIGHT_X_MIN = CENTER_STICK_PS2 - DEADZONE_PS2
  CENTER_PS2_RIGHT_X_MAX = CENTER_STICK_PS2 + DEADZONE_PS2
  CENTER_PS2_RIGHT_Y_MIN = CENTER_STICK_PS2 - DEADZONE_PS2
  CENTER_PS2_RIGHT_Y_MAX = CENTER_STICK_PS2 + DEADZONE_PS2
  CENTER_PS2_LEFT_X_MIN = CENTER_STICK_PS2 - DEADZONE_PS2
  CENTER_PS2_LEFT_X_MAX = CENTER_STICK_PS2 + DEADZONE_PS2
  CENTER_PS2_LEFT_Y_MIN = CENTER_STICK_PS2 - DEADZONE_PS2
  CENTER_PS2_LEFT_Y_MAX = CENTER_STICK_PS2 + DEADZONE_PS2
  CENTER_PS2_LEFT_X_SIZE = CENTER_PS2_LEFT_X_MAX - CENTER_PS2_LEFT_X_MIN
  CENTER_PS2_LEFT_Y_SIZE = CENTER_PS2_LEFT_Y_MAX - CENTER_PS2_LEFT_Y_MIN
  CENTER_PS2_RIGHT_X_SIZE = CENTER_PS2_RIGHT_X_MAX - CENTER_PS2_RIGHT_X_MIN
  CENTER_PS2_RIGHT_Y_SIZE = CENTER_PS2_RIGHT_X_MAX - CENTER_PS2_RIGHT_X_MIN
  MAX_STICK_PS2 = $FF

CON ' SD Card Constants

    ' Actions for Exists routine
  SD_ACTION_NONE = 0   ' No action, return non-zero if file doesn't exist
  SD_ACTION_DELETE = 1 ' Return's 0 if file deleted, returns non-zero if error deleting it
  SD_ACTION_BOOT = 2   ' Boots the file
  SD_ACTION_CREATE = 3 ' Create a 1-line empty file ready for editing

PUB GetObjectName

  result := @objectName